echo off;
DEMO_BOD_FGS(3)=0; E=tf(1,1); S=tf(1,[1 1]);
SP2=S; RE6=E; RE7=E; RE8=E; RE9=E; FI6=E; FI7=E; FI8=E;
echo on;
%DEMO_BOD - Anwendung von bod.m (Digitales Betragsoptimum - BOD)
%Demonstration der wahlweisen Ein-/Ausgabe von LTI-Modellen
%                             und/oder Menabschaltung

%Vorgabe einer Strecke im Laplace-Breich (zwei Verzgerungsglieder
%mit Verstrkung V=1 und den Zeitkonstanten T1=8ms, T2=2ms): 
z=1; n=[16 10 1];
%Transformation der Strecke in den Z-Bereich; Abtastzeit T=2ms;
T=2; [zz,nz]=trans(z,n,T,0,1)
pause,     %Bettigen Sie eine beliebige Taste

%Als Zhler- bzw. Nennerpolynom der Z-bertragungsfunktion resultierten:
%zz =      0   0.0842  0.0556
%nz = 1.0000  -1.1467  0.2865
%Gleiche Anzahl der Pole in Z- und Laplace-Bereich; Totzeit=Abtastzeit
%LTI-Modell im Z-Bereich (vorteilhaft mit negativen Potenzen von z):   
SZ1=tf(zz,nz,T,'Variable','z^-1'),
pause,     %Bettigen Sie eine beliebige Taste

%Streckensprungantwort kontinuierlich und diskontinuierlich mit MATLAB
SP1=tf(z,n,'Variable','p'); grid on; step(SP1,SZ1);
pause,     %Bettigen Sie eine beliebige Taste

%Aufrufvarianten von BOD (SV=Steuervektor bei Menabschaltung - vgl. help):
%                         Fhrungsoptimierung        Stroptimierung mit Vorfilter
%a-alte Syntax mit Men: [rz,rn]=bod(zz,nz)    oder [rz,rn,fz,fn]=bod(zz,nz)
%b-neue Syntax mit Men: [RE]=bod(SZ1)         oder [RE,FI]=bod(SZ1)
%c-alte Syntax ohne Men:[rz,rn]=bod(zz,nz,SV) oder [rz,rn,fz,fn]=bod(zz,nz,SV)
%d-neue Syntax ohne Men:[RE]=bod(SZ1,SV)      oder [RE,FI]=bod(SZ1,SV)
%
% >>>Abschaltung von Textausgaben (z.B. Polanzeige) mit SV(6)=1 - vgl. help<<<
pause,     %Bettigen Sie eine beliebige Taste

%Zu weiteren Zahlenbeispielen vgl.: Geitner, G.-H.  
%"Entwurf digitaler Regler fr elektrische Antriebe" S. 94 bis 107.
% VDE-Verlag GmbH Berlin und Offenbach 1996; ISBN 3-8007-1847-2
pause,     %Bettigen Sie eine beliebige Taste

%Beispiele zur Fhrungsoptimierung:
%=================================
%A1, PI-Regler (Fhrungsoptimierung) ohne Polkompensation
%a  [rz,rn]=bod(zz,nz)    ===> mit Men-Eingaben: bel./bel./bel./1
%    rz = 1.6297  -1.2748
%    rn = 1       -1
%b  [RE]=bod(SZ1)         ===> mit Men-Eingaben: bel./bel./bel./1
%c  [rz,rn]=bod(zz,nz,SV) ===> mit SV=[0 0 0 0 1]
%d:
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV1=[0 0 0 0 1]; RE1=bod(SZ1,SV1)
pause,     %Bettigen Sie eine beliebige Taste

%A2, PI-Regler (Fhrungsoptimierung) mit Polkompensation
%    Men-Eingaben:    bel./1/1/bel./bel./bel.  oder  SV=[0 1 0 1 0]
%    rz = 1.5277  -1.1898
%    rn = 1       -1
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV2=[0 1 0 1 0]; RE2=bod(SZ1,SV2)
pause,     %Bettigen Sie eine beliebige Taste

%A3, PID-Regler (Fhrungsoptimierung) ohne Polkompensation
%    Men-Eingaben:    bel./bel./bel./2   oder  SV=[0 0 0 0 2]
%    rz = 4.6218   -5.4465    1.4386
%    rn = 1         -1        0
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV3=[0 0 0 0 2]; RE3=bod(SZ1,SV3)
pause,     %Bettigen Sie eine beliebige Taste

%A4, PID-Regler (Fhrungsoptimierung) mit Kompensation eines Poles
%    Men-Eingaben:   bel./1/1/bel./bel./1   oder  SV=[0 1 0 1 1]
%    rz = 4.5803   -5.3887    1.4186
%    rn = 1         -1        0
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV4=[0 1 0 1 1]; RE4=bod(SZ1,SV4)
pause,     %Bettigen Sie eine beliebige Taste

%A5, PID-Regler (Fhrungsoptimierung) mit Kompensation beider Pole
%    Men-Eingaben:  bel./bel./bel./2    oder  SV=[0 1 0 2 0]
%    rz = 3.9837   -4.5680    1.1413
%    rn = 1        -1         0
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV5=[0 1 0 2 0]; RE5=bod(SZ1,SV5)
pause,     %Bettigen Sie eine beliebige Taste

%Berechnung des Verhaltens von Stell- und Regelgre fr Beispiel A mit SIMULINK
echo off;
DEMO_BOD_FGS(1)=1; DEMO_BODs; sim('DEMO_BODs',30); DEMO_BOD_FGS(1)=0; echo on;
pause,     %Bettigen Sie eine beliebige Taste

%Beispiele zur Stroptimierung:
%=============================
%B1, PI-Regler (Stroptimierung) ohne Polkompensation
%a  [rz,rn,fz,fn]=bod(zz,nz)    ===> mit Men-Eingaben: 1/bel./bel./1/bel.
%   rz = 1.8460   -1.2610
%   rn = 1        -1
%   fz = 0.3169    0
%   fn = 1.0000   -0.6831  
%b  [RE,FI]=bod(SZ1)            ===> mit Men-Eingaben: 1/bel./bel./1/bel.
%c  [rz,rn,fz,fn]=bod(zz,nz,SV) ===> mit SV=[1 0 0 0 1 1]
%d:
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV6=[1 0 0 0 1 1]; [RE6,FI6]=bod(SZ1,SV6)
pause,     %Bettigen Sie eine beliebige Taste

%B2, PID-Regler (Stroptimierung) mit Kompensation eines Poles
%    Nur zur Demonstration von Warnungen - bitte WARNUNG beachten!!!
%    Men-Eingaben:  1/1/1/bel./bel./1/bel.   oder  SV=[1 1 0 1 1 1]
%    rz = 5.1170  -4.9835   1.1408
%    rn = 1       -1        0
%    fz = 0.3940   0
%    fn = 1.0000  -0.606
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV7=[1 1 0 1 1 1]; [RE7,FI7]=bod(SZ1,SV7)
pause,     %Bettigen Sie eine beliebige Taste

%B3, PID-Regler (Stroptimierung) ohne Polkompensation
%    VARIANTE 1 - der Suchalgorithmus erhlt maschinelle Anfangswerte:
%                 Men-Eingaben:  1/bel./bel./2/bel./bel.    
%                           oder  SV=[1 0 0 0 2 1]
%    VARIANTE 2 - der Suchalgorithmus erhlt Reglerparameter-Schtzwerte 
%                 Men-Eingaben:  1/bel./bel./2/1/bel./4.9/-0.85/0.5
%                           oder  SV=[1 0 0 0 2 1 0 0 0 1 4.9 -0.85 0.5]
%    VARIANTE 3 - der Suchalgorithmus erhlt Reglernullstellen-Schtzwert
%                 Men-Eingaben:  1/bel./bel./2/1/1/0.5/bel.
%                           oder  SV=[1 0 0 0 2 1 0 0 0 2 0.5]
%    rz = 6.3309  -5.9589  1.4063
%    rn = 1       -1       0
%    fz = 0.2809   0       0
%    fn = 1.0000  -0.9413  0.2221
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV8=[1 0 0 0 2 1]; [RE8,FI8]=bod(SZ1,SV8)
pause,     %Bettigen Sie eine beliebige Taste

%Fhrungsverhalten und Strverhalten mit Vorfilter fr Beispiel B
%Verhalten von Stell- und Regelgre 
echo off;
bdclose('DEMO_BODs');  %fr R11 / 5.3 nicht ntig
DEMO_BOD_FGS(2)=1; DEMO_BODs; sim('DEMO_BODs',100), DEMO_BOD_FGS(2)=0; echo on;
pause,     %Bettigen Sie eine beliebige Taste

%C, Beispiel zur Fhrungsoptimierung mit gedmpftem D-Anteil:
%========================================================
%Vorgabe einer Strecke im Laplace-Breich (drei Verzgerungsglieder,
%zwei Zhlerpolynome 1.Ordnung und eine explizite Totzeit Tt=4*T.
%Die Zeitkonstanten werden als Funktion der Abtastzeit T vorgegeben.
pause,     %Bettigen Sie eine beliebige Taste

%Zhler- und Nennerpolynome noch ohne Bercksichtigung der Totzeit
z2=conv([6*T 1],[-4*T 1]);
n2=conv(conv([40*T 1],[12*T 1]),[4*T 1]);
%Laplacebertragungsfunktion unter Bercksichtigung der Totzeit:
SP2=tf(z2,n2,'InputDelay',4*T,'Variable','p'),

%Transformation der Strecke in den Z-Bereich;
[zz2,nz2]=trans(z2,n2,T,4*T,1),
SZ2=tf(zz2,nz2,T,'Variable','z^-1'),
pause,     %Bettigen Sie eine beliebige Taste

%Berechnung mit MATLAB: Streckensprungantwort kontinuierlich und diskontinuierlich
grid on; step(SP2,SZ2),
pause,     %Bettigen Sie eine beliebige Taste

%   PID-Regler (Fhrungsoptimierung) mit Kompensation zweier Pole
%   Men-Eingaben:  bel./1/1/1/bel./bel./bel./1/1 
%             oder  SV=[0 1 0 2 0 0 1 0]
%   rz = 7.3482  -13.9275    6.5938
%   rn = 1.0000   -1.7219    0.7219  = (1 - z^-1)*(1 - 0.7219z^-1)
%   vgl. obige Literaturstelle S.99
pause,     %Bettigen Sie eine beliebige Taste

%Reglerberechnung
SV9=[0 1 0 2 0 0 1 0]; RE9=bod(SZ2,SV9)

%Mit MATLAB Sprungantwort des Regelkreises berechnen: Regelgre
RK9o=series(RE9,SZ2); RK9x=feedback(RK9o,1); figure; grid on; step(RK9x);
pause,     %Bettigen Sie eine beliebige Taste

%Mit MATLAB Sprungantwort des Regelkreises berechnen: Stellgre
RK9y=feedback(RE9,SZ2); figure; grid on; step(RK9y);
pause,     %Bettigen Sie eine beliebige Taste

%Mit SIMULINK Sprungantworten von Stell- und Regelgre berechnen
echo off;
bdclose('DEMO_BODs');  %fr R11 / 5.3 nicht ntig
DEMO_BOD_FGS(3)=1; DEMO_BODs; sim('DEMO_BODs',160), DEMO_BOD_FGS(3)=0;
clear DEMO_BOD_FGS T z n z2 n2 zz nz zz2 nz2 SP1 SP2 SZ1 SZ2
clear SV1 SV2 SV3 SV4 SV5 SV6 SV7 SV8 SV9 RE1 RE2 RE3 RE4 RE5 RE6 RE7 RE8 RE9
clear RK9o RK9x RK9y FI6 FI7 FI8 E S tout
