format compact; echo on;
%DEMO_SIMU - Ein Beispiel zur Anwendung von simu.m:
%Schnelle berprfung von Einstellungen digitaler Regler ohne SIMULINK

%Vorgabe Regelstrecke(Laplce-Bereich) und Reglerberechnung(digital/Z-Bereich):
z=1; n=conv(conv([2 1],[4 1]),[7 1]);  %Zhler- und Nennerdefinition der Strecke
T=2.5; [zz,nz,sdef]=trans(z,n,T,0,2);             %vgl. DEMO_BOD oder help trans
[rz,rn,fz,fn]=bod(zz,nz,[1 1 0 1 1 2]); echo off, %vgl. DEMO_BOD oder help bod
disp('Zhler- und Nennerpolynome von Vorfilter und Regler:');
fz,fn,rz,rn, echo on
pause,                    %Bitte bettigen Sie eine beliebige Taste

%Simulation und Gteparameterberechnung mit simu.m bei Fhrungsgrensprung
%Bitte folgen Sie den Eingabeanweisungen:
zs0=1;       %kein zustzliches Z-Zhlerpolynom zwischen Regler und Strecke
wv=ones(1,40);  wv(1)=0;  %Sollwertvektor; Sprung nicht mit Achse identisch
zv=zeros(1,40);           %Strgrenvektor; keine nderung
[AM1,t,vx,vy,vw2,vz,vq]=simu(fz,fn,rz,rn,zs0,sdef,wv,zv); echo off
disp('Ermittelte Gteparameter gepackt: Auswertung siehe help simu');
disp('                                  Zeitwerte ab Eingangssignalnderung');
if length(AM1)~=1 AM1, 
else disp('Gteparameterberechnung wurde nicht ausgewhlt'); end
echo on;
pause,           %Bitte bettigen Sie eine beliebige Taste

%Simulation und Gteparameterberechnung mit simu.m bei Strgrensprung
%Bitte folgen Sie den Eingabeanweisungen:
zs0=1;       %kein zustzliches Z-Zhlerpolynom zwischen Regler und Strecke
wv=zeros(1,40);         %Sollwertvektor; keine nderung
zv=ones(1,40); zv(1)=0; %Strgrenvektor; Sprung nicht mit Achse identisch
[AM2,t,vx,vy,vw2,vz,vq]=simu(fz,fn,rz,rn,zs0,sdef,wv,zv); echo off
disp('Ermittelte Gteparameter gepackt: Auswertung siehe help simu');
disp('                                  Zeitwerte ab Eingangssignalnderung');
if length(AM2)~=1 AM2,
else disp('Gteparameterberechnung wurde nicht ausgewhlt'); end
clear z n zs0 T zz nz rz rn fz fn AM1 AM2 t vx vy vw2 vz vq