%regber2 - Reglervergleich: BOD-PI(oK/mK), BOD-PID(oK/mK), EEZ(delta=0,1,2)
%Streckensprungantwort(k/d), Reglerberechnung(Fh.) und Regelkreissimulation

%Parameter definieren
VS=2; T1=2; T2=10; T=1;

%bertragungsfunktion im Laplace-Bereich
zp=VS; np=conv([T1 1],[T2 1]);
GP=tf(zp,np),

%Z-Transformation der Streckenbertragunsfunktion
disp([10 'Z-Transformation der Strecke:']);
GZ=trans(GP,T,0,1),

%Diskontinuierlicher Regler: Digitales Betragsoptimum (BOD)
disp([10 'Digitales Betragsoptimum:']);
SVPIoK=[0 0 0 0 1];
SVPImK=[0 1 0 1 0];
SVPIDoK=[0 0 0 0 2];
SVPIDmK=[0 1 0 2 0];
PIoK=bod(GZ,SVPIoK),
PImK=bod(GZ,SVPImK),
PIDoK=bod(GZ,SVPIDoK),
PIDmK=bod(GZ,SVPIDmK),

%Entwurf auf endliche Einstellzeit (EEZ)
disp([10 'Endliche Einstellzeit:']);
SVE0=[0 -1 0 0 0 ];
SVE1=[0 -1 0 1 0 ];
SVE2=[0 -1 0 2 0 ];
EEZ0=eez(GZ,SVE0),
EEZ1=eez(GZ,SVE1),
EEZ2=eez(GZ,SVE2),

%Sprungantworten in SIMULINK berechnen
regber2s;             %SIMULINK-Modell ffnen
sim('regber2s',25),   %SIMULINK-Modell berechnen

